/* 
 You can either let the second window handle it's own drawing or do a noLoop
 and call redraw whenever you want to refresh the view. You call any function
 in the main applet from within ui window so you can communicate back to
 your main view.
 */

// variables for console window
UIWindow uiWindow; 
PFont consoleFont; // must load a font for TextButton 

public class UIWindow extends PApplet { // class for 2nd window
  Frame frame;
  int width;
  int height;
  int fps;
  String windowName;

  PFont font;
  TextButton b1;

  Panel inputPanel;
  TextArea textarea;
  Panel inputPanel2;
  TextArea textarea2; 
  
  boolean isButtonPress;
  String command = "";
  String[] commandList; 
  String transList = "";
  boolean showNet;
  StringBuilder sb = new StringBuilder("");  
  String transHistory = ""; 

  UIWindow (int w, int h, int framerate, PFont fontName, String name) {
    width = w;
    height = h;
    fps = framerate;
    font = fontName;
    windowName = name;
    frame = new Frame();
    frame.setBounds(0, 0, width, height);
    frame.setLocation(0, 0);
    frame.setAlwaysOnTop(true); // set to true/false to control "AlwyasOnTop" parameter
    frame.setResizable(false); // set to true to change window size
    frame.add(this);
    this.init();
    //frame.show();
  }

  void setup() {
    size(width, height);
    frameRate(fps); // framerate for 2nd window
    frame.setTitle(windowName);    
    ConsoleSetup(); // initialize Classes for Console Window
    frame.show();     
    //noLoop();
  }

  void draw() { // add stuff here to draw to 2nd window
    ConsoleDraw(); // draw Classes for Console Window
  }


  void ConsoleSetup() {
    background(50);
    textAlign(CENTER, CENTER);  
    b1 = new TextButton(353, 253, 70, 30, "Enter", font, 24, "1"); // x, y, width, height, label, fontname, fontsize, id;
    strokeWeight(2);
    inputPanel = new Panel();  
    inputPanel.setLayout(new BorderLayout());
    add(inputPanel);
    inputPanel.setBounds(5, 185, 341, 100); // left x, top y, width, height

    textarea = new TextArea("");  
    // A border layout lays out a container, arranging and resizing its components to fit in five regions: 
    // Each region is identified by a corresponding constant: NORTH, SOUTH, EAST, WEST, and CENTER. 
    inputPanel.add(textarea, BorderLayout.CENTER);
    setLayout(new BorderLayout());

    inputPanel2 = new Panel();  
    inputPanel2.setLayout(new BorderLayout());
    add(inputPanel2);
    inputPanel2.setBounds(5, 5, 420, 150); // left x, top y, width, height

    textarea2 = new TextArea("This window displays the history: \n");  
    inputPanel2.add(textarea2, BorderLayout.CENTER);
    setLayout(new BorderLayout());     
  }

  void ConsoleDraw() {
    textAlign(CENTER, CENTER);  
    b1.display();
    textAlign(LEFT, CENTER);
    textFont(font, 20);
    text("enter commands here:", 10, 175);
  }


  ////////////////////////////////////////////////
  //****************ButtonClass*****************//
  ////////////////////////////////////////////////
  String buttonEvent = null;

  public class TextButton { // GUI button class 
    int x_pos;
    int y_pos;
    int w;
    int h;
    String label;
    PFont font;
    int fSize;
    String id;
    boolean pressed = false; 
    int[] normColor = {
      50, 50, 70, 255        };
    int[] overColor = {
      50, 50, 70, 255        };
    int[] clickColor = {
      100, 100, 200, 255        };
    int[] frameColor = {
      255, 255, 255, 255        };
    int[] textColor = {
      255, 255, 255, 255        };
    boolean listen = true; // turns mouse listening on/off
    boolean report = true; // turns reporting on/off

    TextButton (int X, int Y, int wdth, int hgth, String name, PFont fType, int f_size, String ident) {
      x_pos = X;
      y_pos = Y;
      w = wdth;
      h = hgth;
      label = name;
      font = fType;
      fSize = f_size;  
      id = ident;
    }

    void display() {
      stroke(frameColor[0], frameColor[1], frameColor[2]);
      if(listen) {
        if(mouseX >= x_pos && mouseX <= x_pos+w && mouseY >= y_pos && mouseY <= y_pos+h) {
          if(mousePressed) {
            if(buttonEvent == null || buttonEvent == id) {
              fill(clickColor[0], clickColor[1], clickColor[2], clickColor[3]);
              if(!pressed) {
                buttonEvent = id;
                pressed = true;
                if(report) {
                  TextButtonEvent(buttonEvent, label); // report event (id) and label
                }
              }       
            }
            else fill(overColor[0], overColor[1], overColor[2], overColor[3]);
          }
          else {
            fill(overColor[0], overColor[1], overColor[2], overColor[3]);
            buttonEvent = null;
            pressed = false;
          }
        }
        else fill(normColor[0], normColor[1], normColor[2], normColor[3]);
      }
      else fill(normColor[0], normColor[1], normColor[2], normColor[3]);

      rect(x_pos, y_pos, w, h);
      fill(textColor[0], textColor[1], textColor[2], textColor[3]);
      textFont(font, fSize);
      text(label, x_pos + w/2, y_pos + h/2 );     
    }

  }

  void TextButtonEvent(String theEvent, String theLabel ) { // report events in TextButton class
    //println("event id: " + theEvent + ", " + "label: " + theLabel);
    if(theEvent.equals("1")) {    
      isButtonPress = true;
      command = textarea.getText();
      textarea2.append(command + "\n");
      textarea.setText("");
      if(!command.equals("") && !command.equals(" ")) {          
        if(command.substring(command.length()-1).equals(";")) { // chop off final semi-colon from string
          command = command.substring(0, command.length()-1);
        }
        commandList = split(command, ";"); // seperate statements into individual array slots  
        for(int i = 0; i<commandList.length; i++) {
          commandList[i] = trim(commandList[i]); // trim white space, tab, carriage return, etc. from beginning and end
          if(!commandList[i].equals("") && !commandList[i].equals(" ")) {
            evaluateCommand(commandList[i]);  
          }
        }    
      }
    }   
  }

  ///////////////////////////////////////////////////////
  /////////////These are the console commands////////////
  ///////////////////////////////////////////////////////

  void evaluateCommand(String com) { 
    // parse command into appropriate parts
    String comList[] = split(com, ' ');
    String opName = comList[0]; // this is the command name
    int opNameSize = opName.length();
    String temp = com.substring(opNameSize); // chop off command name from command list
    temp = trim(temp);
    boolean hasOpList = true;      
    if(temp.length() == 0) hasOpList = false;
    String[] opList = split(temp, ','); // store the rest of the command list (minus command name)
    //println(opList);  
    for(int i=0; i<opList.length; i++) {    
      opList[i] = trim(opList[i]);
      if(opList[i].equals("") || opList[i].equals(" ")) hasOpList = false;
    }

    // compute transformation network
    if(opName.equals("net") && hasOpList) {
      if(opList[0].equals("clear")) {
        sb.delete(0, sb.length());
        transHistory = "";
        showNet = false;
        for (int i=0; i<trichord.length; i++) { 
          trichord[i].drawLine = false; 
          trichord[i].drawLineXYZ = "";
          if(!trichord[i].textOn) {
            trichord[i].r = tColOff[0];
            trichord[i].g = tColOff[1];
            trichord[i].b = tColOff[2];
          }
        }
      }
      else {
        showNet = true;      
        // parse command into appropriate parts
        int[] origin = int(split(opList[0], ' ')); // store origin set
        int[] current = new int[origin.length];
        arrayCopy(origin, current); // initialize current transformed set to origin
        boolean hasTrans = false;
        if(opList.length > 1) hasTrans = true;
        String[] trans = subset(opList, 1); // store all transformation info here
        transList = ""; // this will store final transformation net as a long string
  
        // if there are transformations to do, do them
        if(hasTrans) {
          boolean state = true; 
          int inc = 0;
          while(state) {  
            if(inc >= trans.length) {     
              inc = 0;
            }
            String[] op = split(trans[inc], ' ');
            op = trim(op);
            if(op.length != origin.length) {
              textarea2.append("error: wrong cardinality!\n");    
              break;      
            }
            for(int i = 0; i < op.length; i++) {
              if(op[i].charAt(0) == 'a') {
                op[i] = op[i].substring(1);
                current[i] = int(float(op[i]) - (current[i] - float(op[i])));
                current[i] = current[i] % 12;
                if(current[i] < 0) current[i] = 12 + current[i];       
              }
              else if(op[i].charAt(0) == 'i') {
                op[i] = op[i].substring(1);
                current[i] = ((12 - current[i]) + int(op[i])) % 12;
                if(current[i] < 0) current[i] = 12 + current[i];       
              }
              else {
                if(op[i].charAt(0) == 't') {
                  op[i] = op[i].substring(1);
                  current[i] = (current[i] + int(op[i])) % 12;
                  if(current[i] < 0) current[i] = 12 + current[i];  
                }
                else {
                  current[i] = (current[i] + int(op[i])) % 12;
                  if(current[i] < 0) current[i] = 12 + current[i];          
                }
              }  
            } 
            transList = transList + " " + current[0] + " " + current[1] + " " + current[2]; // append com elements to end of show string
            transList = trim(transList); 
            inc++;
  
            //if(full) {
            //if(origin[0] == current[0] && origin[1] == current[1] && origin[2] == current[2] && inc == temp.length) state = false;  
            //} 
            //else {
            if(origin[0] == current[0] && origin[1] == current[1] && origin[2] == current[2]) state = false;        
            //} 
          }
  
          if(!state) {   
            String[] temp2 = split(transList, ' ');           
            for (int i=0; i<trichord.length; i++) { 
              if(!trichord[i].drawLine && !trichord[i].textOn ) { 
                //trichord[i].textOn = false; 
                trichord[i].r = tColOff[0];
                trichord[i].g = tColOff[1];
                trichord[i].b = tColOff[2];
              }     
              for(int j=0; j<temp2.length; j+=3) {
                String visible = temp2[j] + " " + temp2[j+1] + " " + temp2[j+2];
                visible = trim(visible);            
                if(visible.equals(trichord[i].tri[0] + " " + trichord[i].tri[1] + " " + trichord[i].tri[2])) {               
                  float deltaX = float(temp2[(j+3) % temp2.length]) - float(temp2[j]);
                  float deltaY = float(temp2[(j+4) % temp2.length]) - float(temp2[j+1]);
                  float deltaZ = float(temp2[(j+5) % temp2.length]) - float(temp2[j+2]); 
                  if(wrapSpace) { 
                    if(deltaX > 6) deltaX = deltaX - 12; 
                    else if(deltaX < -6) deltaX = deltaX + 12;      
                    if(deltaY > 6) deltaY = deltaY - 12; 
                    else if(deltaY < -6) deltaY = deltaY + 12; 
                    if(deltaZ > 6) deltaZ = deltaZ - 12; 
                    else if(deltaZ < -6) deltaZ = deltaZ + 12;
                  }
                  trichord[i].drawLine = true;         
                  trichord[i].drawLineXYZ = trichord[i].drawLineXYZ + " " + str(deltaX) + " " + str(deltaY) + " " + str(deltaZ);
                  trichord[i].drawLineXYZ = trim(trichord[i].drawLineXYZ);
                  //trichord[i].textOn = true;
                  trichord[i].r = tCol[0];
                  trichord[i].g = tCol[1];
                  trichord[i].b = tCol[2];             
                }           
              } 
            }
            if(isButtonPress) {
              sb.append(com + "; "); // keep a running history of all net commands 
              transHistory = sb.toString(); // convert to String               
              //textarea2.append("printing transList: \n"); 
              //textarea2.append(transList + "\n");
              textarea2.append("iterating transList: \n");            
              for(int i = 0; i<temp2.length-1; i+=3) {
                String visible = temp2[i] + " " + temp2[i+1] + " " + temp2[i+2];
                visible = trim(visible);           
                textarea2.append(visible + "\n");   
              } 
              textarea2.append("# of transformations: " + temp2.length/3+ "\n");
            }
          }
        }
      }
    }

    // set speed and speedY variables 
    if(opName.equals("speed") && hasOpList) {
      float sp = float(opList[0]); // 
      if(sp > 0.) { // only pass if conversion doesn't return NaN
        if (currentSpeed == speed) currentSpeed = sp;
        else currentSpeed = fSpeed;
        if (currentSpeedY == speedY) currentSpeedY = sp;
        else currentSpeedY = fSpeedY;     
        speed = sp;
        speedY = sp;
      }    
    } 

    // set fspeed and fspeedY variables 
    if(opName.equals("fspeed") && hasOpList) { 
      float sp = float(opList[0]); // 
      if(sp > 0.) { // only pass if conversion doesn't return NaN      
        if (currentSpeed == fSpeed) currentSpeed = sp;
        else currentSpeed = speed;
        if (currentSpeedY == fSpeedY) currentSpeedY = sp;
        else currentSpeedY = speedY;          
        fSpeed = sp;
        fSpeedY = sp;   
      } 
    } 

    // set easing variable
    if(opName.equals("easing") && hasOpList) { 
      float sp = float(opList[0]); // 
      if(sp > 0.) { // only pass if conversion doesn't return NaN               
        easing = constrain(sp, 0.000001, 1.); 
      } 
    }     

    // set setType variable
    if(opName.equals("displaytype") && hasOpList) {
      if(opList[0].equals("normal")) setType = NORMALFORM;
      if(opList[0].equals("prime")) setType = PRIMEFORM;      
    }

    // set largeSize variable
    if(opName.equals("togglesize")) {    
      if(largeSize) {     
        for (int i=0; i<trichord.length; i++) {
          trichord[i].triSize = trichordSize/2;
          trichord[i].triSize2 = trichordSize;        
        }
        largeSize = false;
      }
      else {
        for (int i=0; i<trichord.length; i++) {
          trichord[i].triSize = trichordSize;
          trichord[i].triSize2 = trichordSize/2;        
        }
        largeSize = true;
      }
    }  

    // set wrapSpace variable
    if(opName.equals("wrapspace") && hasOpList) {
      if(opList[0].equals("on")) wrapSpace = true;
      if(opList[0].equals("off")) {
        wrapSpace = false;
        // get current distance from camera and lookat to trichord 0 0 0
        float[] camDiff = new float[3];
        camDiff[0] = cam[0] - trichord[0].x;
        camDiff[1] = cam[1] - trichord[0].y;
        camDiff[2] = cam[2] - trichord[0].z;
        float[] lookatDiff = new float[3];
        lookatDiff[0] = lookat[0] - trichord[0].x;
        lookatDiff[1] = lookat[1] - trichord[0].y;
        lookatDiff[2] = lookat[2] - trichord[0].z;         
        // reposition all trichords back near the world origin 
        for(int i = 0; i < trichord.length; i++) {
          trichord[i].resetTranslate();
        }
        // move the camera and lookat to maintain the same relative relationship
        cam[0] = trichord[0].x + camDiff[0];
        cam[1] = trichord[0].y + camDiff[1];
        cam[2] = trichord[0].z + camDiff[2];         
        lookat[0] = trichord[0].x + lookatDiff[0];
        lookat[1] = trichord[0].y + lookatDiff[1];
        lookat[2] = trichord[0].z + lookatDiff[2];    
      }
      
      for (int i=0; i<trichord.length; i++) { 
        trichord[i].drawLine = false; 
        trichord[i].drawLineXYZ = "";
      }
      genTransformations();
    }

    // set multiSets variable 
    if(opName.equals("multisets") && hasOpList) {
      if(opList[0].equals("on")) multiSets = true;
      if(opList[0].equals("off")) multiSets = false;      
    } 
    // set permuteEquiv variable 
    if(opName.equals("equivalence") && hasOpList) {
      if(opList[0].equals("on")) permuteEquiv = true;
      if(opList[0].equals("off")) permuteEquiv = false;      
    }

    // set show variable 
    if(opName.equals("show") && hasOpList) {
      //transHistory = "net clear;";
      //genTransformations();
      
      if(opList[0].equals("all")) show = "all";
      else if(opList[0].equals("clear")) show = "clear";
      
      else if(comList[1].equals("ic")) {
        if(show.equals("all") || show.equals("clear")) show = ""; // if show starts with "all" or "clear, clear show        

        temp = temp.substring(comList[1].length()); // chop off "ic" from temp string
        temp = trim(temp);
        hasOpList = true;
        if(temp.length() == 0) hasOpList = false;
        else {
          temp = temp.replaceAll(",", ""); // just in case commas were added!
          opList = split(temp, "not"); // included ics in 1st slot, excluded in 2nd (anything else we'll ignore)         
          //println(opList);  
          for(int i=0; i<opList.length; i++) {    
            opList[i] = trim(opList[i]);
            //if(opList[i].equals("") || opList[i].equals(" ")) hasOpList = false;          
          }
        }
        // using an Arraylist to store all prime forms that contain the appropriate ic
        ArrayList withIC;
        withIC = new ArrayList(); 
        // store included ics in one array, excluded ics in another array
        String[] incList = split(opList[0], ' ');
        boolean hasIncList;   
        if(incList.length == 1 && (incList[0].equals("") || incList[0].equals(" "))) hasIncList = false;
        else hasIncList = true; 
      
        for(int i=0; i<incList.length; i++) {
         if(int(incList[i]) < 0 || int(incList[i]) > 6) {
           hasOpList = false;
           textarea2.append("error: interval classes are only between 0 and 6\n");
         }
        } 
        
        String[] excList = {""};
        boolean hasExcList;
        if(opList.length > 1) {
          hasExcList = true;
          excList = split(opList[1], ' ');
        }
        else hasExcList = false;

        for(int i=0; i<excList.length; i++) {
         if(int(excList[i]) < 0 || int(excList[i]) > 6) {
           hasOpList = false;
           textarea2.append("error: interval classes are only between 0 and 6\n");
         }
        } 
        
        // trim whitespace / check for illegal formatting in both arrays
        if(hasIncList) {
          for(int i=0; i<incList.length; i++) {    
            incList[i] = trim(incList[i]);
            if(incList[i].equals("") || incList[i].equals(" ")) hasOpList = false;          
          }
        }
        if(hasExcList) {
          for(int i=0; i<excList.length; i++) {    
            excList[i] = trim(excList[i]);
            if(excList[i].equals("") || excList[i].equals(" ")) hasOpList = false;          
          } 
        } 
        if(hasOpList) {     
          for(int i=0; i<trichord.length/8; i++) {
            boolean containsIC = false;
            boolean excludesIC = false;
            int incMatches = 0;
            int excMatches = 0;
            int pOne = trichord[i].primeTri[1];
            if(pOne > 6) pOne = 12 - pOne;
            int pTwo = trichord[i].primeTri[2];
            if(pTwo > 6) pTwo = 12 - pTwo;
            int icDif = trichord[i].primeTri[2] - trichord[i].primeTri[1]; // ic between 2nd and 3rd members
            if(icDif > 6) icDif = 12 - icDif;          
            
            // check for matching ics in each trichord 
            for(int j=0; j<incList.length; j++) {
              if(incList[j].equals(str(pOne)) ||
              incList[j].equals(str(pTwo)) ||
              incList[j].equals(str(icDif))) incMatches++; // ic is contained within this trichord
            }
            if(incMatches == incList.length || !hasIncList) containsIC = true; // ics are contained within this trichord
            // check for excluded ics in each trichord           
            for(int j=0; j<excList.length; j++) {
              if(!excList[j].equals(str(pOne)) &&
              !excList[j].equals(str(pTwo)) &&
              !excList[j].equals(str(icDif))) excMatches++; // ic IS NOT contained within this trichord
            } 
            if(excMatches == excList.length || !hasExcList) excludesIC = true; // ics are excluded from this trichord      
            if(containsIC && excludesIC) {
              String currentPrime = trichord[i].primeTri[0] + " " + trichord[i].primeTri[1] + " " + trichord[i].primeTri[2];
              boolean noDuplicates = true;
              for(int j=0; j<withIC.size(); j++) {
                if(currentPrime.equals(withIC.get(j))) noDuplicates = false;
              }
              if(noDuplicates) { // only add prime form to the list if it isn't a duplicate
                withIC.add(currentPrime);
                for(int k=0; k<withIC.size(); k++) {                
                  show = show + " " + withIC.get(k); // append all withIC elements to end of show string
                  show = trim(show); 
                } 
              }
            }        
          }
          //println(show);
        }  
      }
      
      else {
        if(show.equals("all") || show.equals("clear")) show = ""; // if show starts with "all" or "clear", clear show
        for(int i = 0; i < opList.length; i++) {
          String[] checkCard = split(opList[i], ' ');
          if(checkCard.length == 3) { // if opList[i] is correctly formatted (i.e. has 3 elements), add to show list       
            show = show + " " + opList[i]; // append opList elements to end of show string
            show = trim(show);
          }
        }
      }
      
      if(hasOpList) {     
        for (int i=0; i<trichord.length; i++) {
          if(show.equals("all")) {
            trichord[i].textOn = false;
            trichord[i].r = tCol[0];
            trichord[i].g = tCol[1];
            trichord[i].b = tCol[2];
          }
          else if(show.equals("clear")) {
            trichord[i].textOn = false;            
            if(!trichord[i].drawLine) {
              trichord[i].r = tColOff[0];
              trichord[i].g = tColOff[1];
              trichord[i].b = tColOff[2];
            }
          }          
          else {
            String[] tempShow = split(show, ' ');   
            for(int j = 0; j < tempShow.length-1; j+=3) {
              String[] temp2 = subset(tempShow, j, 3);
              String visible = temp2[0] + " " + temp2[1] + " " + temp2[2];
              visible = trim(visible);
              if(visible.equals(trichord[i].primeName)) {
                trichord[i].textOn = true;
                trichord[i].r = tCol[0];
                trichord[i].g = tCol[1];
                trichord[i].b = tCol[2];
              }              
              else {
                if(!trichord[i].textOn && !trichord[i].drawLine) {
                  trichord[i].textOn = false;
                  trichord[i].r = tColOff[0];
                  trichord[i].g = tColOff[1];
                  trichord[i].b = tColOff[2];   
                }             
              }
            }
          }
        }
        //println(show);   
      }      
    }
      
    // set window bg color variable
    if(opName.equals("bgcolor") && hasOpList) {         
      String[] colors = split(opList[0], ' '); // store the rest of the command list (minus 1st and 2nd command names)
      if(colors.length == 3) {  
        bgColor[0] = constrain(int(colors[0]), 0, 255);
        bgColor[1] = constrain(int(colors[1]), 0, 255);
        bgColor[2] = constrain(int(colors[2]), 0, 255);
      }
      else textarea2.append("error: color should be three values (red, green, blue)\nexample: bgcolor 10 50 200;\n");       
    } 
    
    // set text on color variable
    if(opName.equals("texton") && hasOpList) {         
      String[] colors = split(opList[0], ' '); // store the rest of the command list (minus 1st and 2nd command names)
      int[] ptCol = {tCol[0], tCol[1], tCol[2]}; // store previous tCol values
      if(colors.length == 3) { 
        tCol[0] = constrain(int(colors[0]), 0, 255);
        tCol[1] = constrain(int(colors[1]), 0, 255);
        tCol[2] = constrain(int(colors[2]), 0, 255);
      }
      else textarea2.append("error: color should be three values (red, green, blue)\nexample: texton 0 0 0;\n"); 

      for(int i=0; i<trichord.length; i++) {
        if(trichord[i].r == ptCol[0]) trichord[i].r = tCol[0];
        if(trichord[i].g == ptCol[1]) trichord[i].g = tCol[1];
        if(trichord[i].b == ptCol[2]) trichord[i].b = tCol[2];
      }
    
    } 

    // set text off color variable
    if(opName.equals("textoff") && hasOpList) {         
      String[] colors = split(opList[0], ' '); // store the rest of the command list (minus 1st and 2nd command names)
      int[] ptColOff = {tColOff[0], tColOff[1], tColOff[2]}; // store previous tColOff values
      if(colors.length == 3) {  
        tColOff[0] = constrain(int(colors[0]), 0, 255);
        tColOff[1] = constrain(int(colors[1]), 0, 255);
        tColOff[2] = constrain(int(colors[2]), 0, 255);
      }
      else textarea2.append("error: color should be three values (red, green, blue)\nexample: textoff 180 180 180;\n"); 
      
      for(int i=0; i<trichord.length; i++) {
        if(trichord[i].r == ptColOff[0]) trichord[i].r = tColOff[0];
        if(trichord[i].g == ptColOff[1]) trichord[i].g = tColOff[1];
        if(trichord[i].b == ptColOff[2]) trichord[i].b = tColOff[2];
      }
    }

    // set text off color variable
    if(opName.equals("netcolor") && hasOpList) {         
      String[] colors = split(opList[0], ' '); // store the rest of the command list (minus 1st and 2nd command names)
      if(colors.length == 3) {  
        netCol[0] = constrain(int(colors[0]), 0, 255);
        netCol[1] = constrain(int(colors[1]), 0, 255);
        netCol[2] = constrain(int(colors[2]), 0, 255);
      }
      else textarea2.append("error: color should be three values (red, green, blue)\nexample: netcolor 50 50 50;\n");
    }     
    
  }

  void genTransformations() { // report events in TextButton class
    if(transHistory.length() > 0) {  
      isButtonPress = false;
      if(transHistory.substring(transHistory.length()-1).equals(";")) { // chop off final semi-colon from string
        transHistory = transHistory.substring(0, transHistory.length()-1);
      }
      commandList = split(transHistory, ";"); // seperate statements into individual array slots  
      commandList = trim(commandList); // trim white space, tab, carriage return, etc. from beginning and end
      for(int i = 0; i<commandList.length; i++) {
        if(!commandList[i].equals("") && !commandList[i].equals(" ")) {
          evaluateCommand(commandList[i]);  
        }
      }
    }    
  } 

}








